import subprocess
import threading
import wx
import pexpect
import sys
import re









def process(command):
     return subprocess.Popen(command, stdout=subprocess.PIPE)

def top(delay):
     command = ["top", "-b", "-d", str(delay)]
     return process(command)

def get_fields(datainput, fields):
     for line in datainput:
         for field, regexp in fields:
             match = re.search(regexp, line)
             if match:
                 yield field, int(match.groups()[0])
def runapp6(app,textBox,principal):

    top_fields = [("total_memory", "^Mem:.*\s(\d+)k\s*total"),
     ("free_memory", "^Mem:.*\s(\d+)k\s*free"),
     ("free_swap", "^Swap:.*\s(\d+)k\s*free")]

    popen = top(delay=1.0)
    for field, value in get_fields(popen.stdout, top_fields):
        print field, value # hacer algo con field y value
        textBox.AppendText(field)
     

def runapp5(app,textBox,principal):
    sp = subprocess
    popen = sp.Popen(["expect"], stdin=sp.PIPE, stdout=sp.PIPE)
    popen.stdin.write("\n".join(["spawn ./out.py", "expect"]))
    popen.stdin.flush()
    for line in readlines(popen.stdout):
        print line,
    popen.wait()

def runapp3(app,textBox,principal):

    for line in pexpect.spawn(app):
        textBox.AppendText(line)
        textBox.Update()
        print line,


def runapp(app,textBox,principal):
    

     pr = subprocess.Popen(app.split(), stdin=None, stdout = subprocess.PIPE, 
                           stderr=subprocess.PIPE)


     # lanzar treads
     tout = readfile(pr.stdout, "StdOut", analizadatos,textBox,principal)
     terr = readfile(pr.stderr, "StdErr", analizadatos,textBox,principal)
     
     
     
     tout.start()
     terr.start()

     pr.wait()
     print "finalizado con codigo %s" % pr.poll()
     return pr
def analizadatos(pipa, msg,textBox,principal):
     a="%s:%s" % (pipa, msg)
     print a
     #sys.stdout.flush()
     textBox.AppendText(msg)
     #textBox.write(msg)
     #textBox.Update()
     #principal.Update()
     #wx.TextCtrl.Update()
     

class readfile(threading.Thread):
     lck = threading.Lock()
     def __init__(self, file, pipa, callback, textBox,principal):
         threading.Thread.__init__(self)
         self.file = file
         self.pipa = pipa
         self.callback = callback
         self.textBox=textBox
         self.principal=principal
     def run(self):
         while 1:
             msg = self.file.readline()
             
             if not msg:
                 break
             #bloquear, ejecutar funcion y desbloquear
             self.lck.acquire()
             self.callback(self.pipa, msg ,self.textBox,self.principal)
             self.lck.release()


#runapp("ping resoli.uclm.es")

